#property copyright "Copyright 2012, www.volatility-factor.com"
#property link      "http://www.volatility-factor.com"

extern int Magic = 2012345;
extern string EA_Comment = "VolatilityFactor";
extern double MaxSpread = 3.5;
extern int Slippage = 2;
extern bool NFA = FALSE;
bool gi_104 = FALSE;
bool AutoGMT_Offset = FALSE;
extern int ManualGMT_Offset = 2;
extern string CS = "==== Custom Settings ====";
bool gi_124 = TRUE;
extern int BetterPricePips = 0;
extern int MaxNegAdds = 3;
extern int ForceProfit = 0;
extern int ForceLoss = 0;
extern int FixedTakeProfit = 0;
extern int FixedStopLoss = 0;
bool gi_152 = FALSE;
string gs_gbpusd_156 = "GBPUSD";
extern string MM = "==== Risk Management ====";
extern bool RecoveryMode = FALSE;
extern double FixedLots = 0.1;
extern double AutoMM = 0.0;
extern double AutoMM_Max = 5.0;

//=============== 
// dll vars
//===============
int _BETTERPRICEPIPS;
int _MAXNEGADDS;
int _FORCEPROFIT;
int _FORCELOSS;
int _FIXEDTAKEPROFIT;
int _FIXEDSTOPLOSS;
int _BANDPER;
int _BANDPER_OPEN;
int _BREAKENTRY;
int _MAXBREAKENTRY;
int _BREAKEXIT;
int _TREND_PER;
int _TRENDDIST;
int _TREND_PER_2;
int _TRENDDIST_2;
int _EXITTIME;
int _EXITTIMEPROFIT;
int _EXITTIMEFORCEPROFIT;
int _MINBANDDIST;
int _RESCUEPROFIT;
int _NOTRENDHOUR1;
int _NOTRENDHOUR2;
int _NOTRENDHOUR3;
int _NOTRENDHOUR4;
int _FRIDAYENDHOUR;
//===============

int gi_200 = 100;
int BandPer = 0;
int BandPer_Open = 0;
int BreakEntry = 0;
int MaxBreakEntry = 0;
int BreakExit = 0;
int TrendPer = 0;
int gi_228 = 0;
int gi_232 = 0;
int gi_236 = 0;
int gi_240 = 0;
int gi_244 = 0;
int gi_248 = 0;
int gi_252 = -1;
int gi_256 = 100;
double gd_260 = 10.0;
double gd_268 = 1.05;
int gi_276 = 3;
int gi_280 = 3;
int gi_284 = 0;
int gi_288 = 0;
int AuthStatus = -1;
string MyPair = "";
int gi_304 = 2;
bool gi_308 = TRUE;
bool IsInetOnline = FALSE;
int gi_316 = 0;
double gd_320 = 0.01;
double gd_328 = 0.01;
double gd_336 = 0.01;
int gi_344 = 100000;
double gd_348 = 1000.0;
double gd_356 = 0.0001;
double gd_364 = 0.1;
int gi_372 = 0;
double gd_376 = 1.0;


void init() {
   gi_308 = TRUE;
   AuthStatus = -1;
   Comment("");
   if (ObjectFind("BKGR") >= 0) ObjectDelete("BKGR");
   if (ObjectFind("BKGR2") >= 0) ObjectDelete("BKGR2");
   if (ObjectFind("BKGR3") >= 0) ObjectDelete("BKGR3");
   if (ObjectFind("BKGR4") >= 0) ObjectDelete("BKGR4");
   if (ObjectFind("LV") >= 0) ObjectDelete("LV");
}

int deinit() {
   Comment("");
   if (ObjectFind("BKGR") >= 0) ObjectDelete("BKGR");
   if (ObjectFind("BKGR2") >= 0) ObjectDelete("BKGR2");
   if (ObjectFind("BKGR3") >= 0) ObjectDelete("BKGR3");
   if (ObjectFind("BKGR4") >= 0) ObjectDelete("BKGR4");
   if (ObjectFind("LV") >= 0) ObjectDelete("LV");
   if (AuthStatus != -1) AuthStatus = SessionOff();
   return (0);
}

int start() {
   double ld_8;
   color li_32;
   int li_168;
   color li_220;
   string ls_328;
   string ls_0 = "";
   double ld_40 = 0;
   double ld_48 = 0;
   double ld_56 = 0;
   double ld_64 = 0;
   double ld_72 = 0;
   double ld_80 = 1;
   if (DayOfWeek() == 1 && iVolume(NULL, PERIOD_D1, 0) < 5.0) return (0);
   if (StringLen(Symbol()) < 6) return (0);
   if (gi_308) {
      Comment("\nInitializing ...");
      Sleep(1000);
      RefreshRates();
      gi_308 = FALSE;
      gi_316 = MarketInfo(Symbol(), MODE_STOPLEVEL);
      gd_320 = MarketInfo(Symbol(), MODE_MINLOT);
      gd_328 = MarketInfo(Symbol(), MODE_MAXLOT);
      gi_344 = MarketInfo(Symbol(), MODE_LOTSIZE);
      gd_336 = MarketInfo(Symbol(), MODE_LOTSTEP);
      gd_348 = MarketInfo(Symbol(), MODE_MARGINREQUIRED);
      if (Digits <= 3) gd_356 = 0.01;
      else gd_356 = 0.0001;
      if (Digits == 3 || Digits == 5) gd_364 = 0.1;
      else gd_364 = 1;
      Sleep(1000);
      //IsInetOnline = CheckWWW();
      IsInetOnline = true;
      Sleep(1000);
      if (!IsInetOnline) gi_308 = TRUE;
   }
   if ((!IsTesting()) && IsStopped()) return (0);
   if ((!IsTesting()) && !IsTradeAllowed()) return (0);
   if ((!IsTesting()) && IsTradeContextBusy()) return (0);
   if (IsDllsAllowed() == FALSE) {
      Comment("\nWarning: Set Parameter **AllowDLL Imports** ON in menu Tools -> Options -> ExpertAdvisors.");
      Print("Warning: Set Parameter **AllowDLL Imports** ON in menu Tools -> Options -> ExpertAdvisors.");
      Alert("Warning: Set Parameter **AllowDLL Imports** ON in menu Tools -> Options -> ExpertAdvisors.");
      Sleep(30000);
      return (0);
   }
   if (StringSubstr(Symbol(), 0, 6) != "GBPUSD" && StringSubstr(Symbol(), 0, 6) != "EURUSD") {
      Comment("\nUnsupported currency pair! Supported currency pairs: GBPUSD and EURUSD(Premium license only)");
      Alert("Unsupported currency pair! Supported currency pairs: GBPUSD and EURUSD(Premium license only)");
      Sleep(10000);
      return (0);
   }
   if (!IsTesting() && Period() != PERIOD_M15) {
      Comment("\nPlease, swich to M15 chart!");
      Alert("Please, swich to M15 chart!");
      Sleep(10000);
      return (0);
   }
   if (AuthStatus <= 0) {
      if (!IsInetOnline) {
         Comment("\nInternet connection problem");
         Alert("Internet connection problem");
         Sleep(10000);
         return (0);
      }
      AuthStatus = f0_4();
      Sleep(1000);
      if (AuthStatus < 0) Comment("\nInitializing ...");
   }
   if (AuthStatus <= 0) {
      if (AuthStatus == -1) {
         Comment("\nAccount login check is failed! Please, start VolatilityFactor, after successful login in your MT4 account!");
         Alert("Account login check is failed! Please, start VolatilityFactor, after successful login in your MT4 account!");
      } else {
         if (AuthStatus == -2) {
            Comment("\nOnline authorization is failed! Please, register your account at http://www.volatility-factor.com/account/activation and restart your MT4 platform!");
            Alert("Online authorization is failed! Please, register your account at http://www.volatility-factor.com/account/activation and restart your MT4 platform!");
         } else {
            if (AuthStatus == -7) {
               Comment("\nInaccurate local system time! Please, synchronize your computer system time and then restart your MT4 platform!");
               Alert("Inaccurate local system time! Please, synchronize your computer system time and then restart your MT4 platform!");
            } else {
               if (AuthStatus == -8) {
                  Comment("\nUnsupported currency pair " + MyPair + ", Bid: " + DoubleToStr(Bid, Digits) + ", Ask: " + DoubleToStr(Ask, Digits) + ". Supported currency pairs: GBPUSD and EURUSD(Premium license only)");
                  Alert("Unsupported currency pair " + MyPair + ", Bid: " + DoubleToStr(Bid, Digits) + ", Ask: " + DoubleToStr(Ask, Digits) + ". Supported currency pairs: GBPUSD and EURUSD(Premium license only)");
               } else {
                  if (AuthStatus == -9) {
                     Comment("\nLocal authorization check is failed! Please, restart MT4 platform!");
                     Alert("Local authorization check is failed! Please, restart MT4 platform!");
                  } else {
                     Comment("\nInitialization is failed with error code " + DoubleToStr(AuthStatus, 0));
                     Alert("Initialization is failed with error code " + DoubleToStr(AuthStatus, 0));
                  }
               }
            }
         }
      }
      Sleep(10000);
      return (0);
   }
   if (ForceProfit <= 0 || ForceLoss <= 0 || BandPer <= 0 || BandPer_Open <= 0 || TrendPer <= 0) {
      Comment("\nWrong initialization parameters for pair " + Symbol());
      Alert("Wrong initialization parameters for pair " + Symbol());
      Sleep(10000);
      return (0);
   }
   double ld_88 = 0;
   double ld_96 = 0;
   double ld_104 = 0;
   double ld_112 = 0;
   double ld_120 = 0;
   double ld_128 = 0;
   bool li_136 = FALSE;
   bool li_140 = FALSE;
   int li_144 = 0;
   int li_148 = 0;
   int li_152 = 0;
   int li_156 = 0;
   int li_160 = 0;
   int li_164 = 0;
   double ld_176 = 0;
   if (StringSubstr(AccountCurrency(), 0, 3) == "JPY") {
      ld_176 = MarketInfo("USDJPY" + StringSubstr(Symbol(), 6), MODE_BID);
      if (ld_176 > 0.1) ld_80 = ld_176;
      else ld_80 = 83;
   }
   if (StringSubstr(AccountCurrency(), 0, 3) == "GBP") {
      ld_176 = MarketInfo("GBPUSD" + StringSubstr(Symbol(), 6), MODE_BID);
      if (ld_176 > 0.1) ld_80 = 1 / ld_176;
      else ld_80 = 0.6329113924;
   }
   if (StringSubstr(AccountCurrency(), 0, 3) == "EUR") {
      ld_176 = MarketInfo("EURUSD" + StringSubstr(Symbol(), 6), MODE_BID);
      if (ld_176 > 0.1) ld_80 = 1 / ld_176;
      else ld_80 = 0.7575757576;
   }
   ld_48 = MathCeil(1.0 / ld_80 / 100.0 * AccountBalance() / gd_336 / (gi_344 / 100)) * gd_336;
   if (AutoMM > 0.0 && (!RecoveryMode)) ld_40 = MathMax(gd_320, MathMin(gd_328, MathCeil(MathMin(AutoMM_Max, AutoMM) / ld_80 / 100.0 * AccountFreeMargin() / gd_336 / (gi_344 / 100)) * gd_336));
   if (AutoMM > 0.0 && RecoveryMode) ld_40 = f0_1();
   if (AutoMM == 0.0) ld_40 = FixedLots;
   double ld_184 = 0;
   double ld_192 = 0;
   double ld_200 = 0;
   double ld_208 = 0;
   for (int li_216 = 0; li_216 <= OrdersTotal() - 1; li_216++) {
      if (!OrderSelect(li_216, SELECT_BY_POS, MODE_TRADES)) Print("Error in OrderSelect! Position:", li_216);
      else {
         if (OrderType() <= OP_SELL && OrderSymbol() == Symbol()) {
            if (OrderMagicNumber() != Magic) {
               if (OrderType() == OP_BUY) li_160++;
               else li_164++;
            }
            if (OrderMagicNumber() == Magic) {
               ld_72 += OrderProfit();
               if (OrderType() == OP_BUY) ld_56 = (Bid - OrderOpenPrice()) / gd_356;
               else ld_56 = (OrderOpenPrice() - Ask) / gd_356;
               ld_64 += ld_56;
               if (OrderType() == OP_BUY) {
                  li_152++;
                  ld_104 += OrderOpenPrice() * OrderLots();
                  ld_120 += OrderLots();
                  li_144 = MathMax(li_144, OrderOpenTime());
                  if (ld_88 < Point || OrderOpenPrice() < ld_88) ld_88 = OrderOpenPrice();
                  if (!(FixedTakeProfit > 0 || FixedStopLoss > 0)) continue;
                  if (ld_184 < Point && ld_192 < Point) {
                     ld_184 = OrderStopLoss();
                     ld_192 = OrderTakeProfit();
                  }
                  if (ld_184 < Point && ld_192 < Point) {
                     if (FixedStopLoss > 0) ld_184 = MathMin(OrderOpenPrice() - FixedStopLoss * gd_356, Bid - gi_316 * Point);
                     if (FixedTakeProfit > 0) ld_192 = MathMax(OrderOpenPrice() + FixedTakeProfit * gd_356, Ask + gi_316 * Point);
                  }
                  if (!(OrderStopLoss() < Point && OrderTakeProfit() < Point)) continue;
                  if (!(MathAbs(ld_184 - OrderStopLoss()) >= Point || MathAbs(ld_192 - OrderTakeProfit()) >= Point)) continue;
                  OrderModify(OrderTicket(), OrderOpenPrice(), ld_184, ld_192, 0, CLR_NONE);
                  continue;
               }
               li_156++;
               ld_112 += OrderOpenPrice() * OrderLots();
               ld_128 += OrderLots();
               li_148 = MathMax(li_148, OrderOpenTime());
               if (ld_96 < Point || OrderOpenPrice() > ld_96) ld_96 = OrderOpenPrice();
               if (FixedTakeProfit > 0 || FixedStopLoss > 0) {
                  if (ld_200 < Point && ld_208 < Point) {
                     ld_200 = OrderStopLoss();
                     ld_208 = OrderTakeProfit();
                  }
                  if (ld_200 < Point && ld_208 < Point) {
                     if (FixedStopLoss > 0) ld_200 = MathMax(OrderOpenPrice() + FixedStopLoss * gd_356, Ask + gi_316 * Point);
                     if (FixedTakeProfit > 0) ld_208 = MathMin(OrderOpenPrice() - FixedTakeProfit * gd_356, Bid - gi_316 * Point);
                  }
                  if (OrderStopLoss() < Point && OrderTakeProfit() < Point)
                     if (MathAbs(ld_200 - OrderStopLoss()) >= Point || MathAbs(ld_208 - OrderTakeProfit()) >= Point) OrderModify(OrderTicket(), OrderOpenPrice(), ld_200, ld_208, 0, CLR_NONE);
               }
            }
         }
      }
   }
   if (li_152 > 0 && ld_120 > 0.0) ld_104 = NormalizeDouble(ld_104 / ld_120, Digits);
   if (li_156 > 0 && ld_128 > 0.0) ld_112 = NormalizeDouble(ld_112 / ld_128, Digits);
   if ((!IsTesting()) || IsVisualMode()) {
      if ((!IsTesting() || TimeCurrent() >= gi_372 + 1) || !gi_124 || iVolume(NULL, PERIOD_M1, 0) <= 1.0) {
         gi_372 = TimeCurrent();
         li_220 = SeaGreen;
         if (ld_40 > 3.0 * ld_48) li_220 = Red;
         else
            if (ld_40 > 1.5 * ld_48) li_220 = OrangeRed;
         if (ObjectFind("BKGR") < 0) {
            ObjectCreate("BKGR", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("BKGR", "g", 110, "Webdings", DarkSlateGray);
            ObjectSet("BKGR", OBJPROP_CORNER, 0);
            ObjectSet("BKGR", OBJPROP_BACK, TRUE);
            ObjectSet("BKGR", OBJPROP_XDISTANCE, 5);
            ObjectSet("BKGR", OBJPROP_YDISTANCE, 15);
         }
         if (ObjectFind("BKGR2") < 0) {
            ObjectCreate("BKGR2", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("BKGR2", "g", 110, "Webdings", li_220);
            ObjectSet("BKGR2", OBJPROP_BACK, TRUE);
            ObjectSet("BKGR2", OBJPROP_XDISTANCE, 5);
            ObjectSet("BKGR2", OBJPROP_YDISTANCE, 60);
         } else ObjectSet("BKGR2", OBJPROP_COLOR, li_220);
         if (ObjectFind("BKGR3") < 0) {
            ObjectCreate("BKGR3", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("BKGR3", "g", 110, "Webdings", li_220);
            ObjectSet("BKGR3", OBJPROP_CORNER, 0);
            ObjectSet("BKGR3", OBJPROP_BACK, TRUE);
            ObjectSet("BKGR3", OBJPROP_XDISTANCE, 5);
            ObjectSet("BKGR3", OBJPROP_YDISTANCE, 45);
         } else ObjectSet("BKGR3", OBJPROP_COLOR, li_220);
         if (ObjectFind("LV") < 0) {
            ObjectCreate("LV", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("LV", "VOLATILITY FACTOR", 9, "Tahoma Bold", White);
            ObjectSet("LV", OBJPROP_CORNER, 0);
            ObjectSet("LV", OBJPROP_BACK, FALSE);
            ObjectSet("LV", OBJPROP_XDISTANCE, 13);
            ObjectSet("LV", OBJPROP_YDISTANCE, 23);
         }
         if (ObjectFind("BKGR4") < 0) {
            ObjectCreate("BKGR4", OBJ_LABEL, 0, 0, 0);
            ObjectSetText("BKGR4", "g", 110, "Webdings", li_220);
            ObjectSet("BKGR4", OBJPROP_CORNER, 0);
            ObjectSet("BKGR4", OBJPROP_BACK, TRUE);
            ObjectSet("BKGR4", OBJPROP_XDISTANCE, 5);
            if (AutoMM > 0.0) ObjectSet("BKGR4", OBJPROP_YDISTANCE, 145);
            else ObjectSet("BKGR4", OBJPROP_YDISTANCE, 122);
         } else ObjectSet("BKGR4", OBJPROP_COLOR, li_220);
         ls_0 = ls_0 
            + "\n  " 
            + "\n " 
            + "\n  Authorization - OK!" 
            + "\n -----------------------------------------------" 
            + "\n  GMT : " + TimeToStr(TimeCurrent() - 3600 * gi_304, TIME_DATE|TIME_MINUTES|TIME_SECONDS) 
            + "\n  Broker : " + TimeToStr(TimeCurrent(), TIME_DATE|TIME_MINUTES|TIME_SECONDS) 
            + "\n  Broker GMT Offset: " + gi_304 
            + "\n -----------------------------------------------" 
            + "\n  Force SL / TP = " + ForceLoss + " / " + ForceProfit + " pips" 
            + "\n  Fixed SL / TP = " + FixedStopLoss + " / " + FixedTakeProfit + " pips" 
         + "\n  Spread = " + DoubleToStr((Ask - Bid) / gd_356, 1) + " pips";
         if (Ask - Bid > MaxSpread * gd_356) ls_0 = ls_0 + " - TOO HIGH";
         else ls_0 = ls_0 + " - NORMAL";
         ls_0 = ls_0 
         + "\n -----------------------------------------------";
         if (AutoMM > 0.0) {
            ls_0 = ls_0 
               + "\n  AutoMM - ENABLED" 
            + "\n  Risk = " + DoubleToStr(AutoMM, 1) + "%";
         }
         ls_0 = ls_0 
         + "\n  Lots = " + DoubleToStr(ld_40, 2);
         if (ld_40 <= 1.5 * ld_48) ls_0 = ls_0 + " - LOW RISK";
         if (ld_40 > 1.5 * ld_48 && ld_40 <= 3.0 * ld_48) ls_0 = ls_0 + " - MODERATE RISK";
         if (ld_40 > 3.0 * ld_48) ls_0 = ls_0 + " - HIGH RISK !!!";
         ls_0 = ls_0 
         + "\n -----------------------------------------------";
         if (RecoveryMode) {
            ls_0 = ls_0 
            + "\n  Recovery Mode - ENABLED";
         } else {
            ls_0 = ls_0 
            + "\n  Recovery Mode - DISABLED";
         }
         ls_0 = ls_0 
         + "\n -----------------------------------------------";
         ls_0 = ls_0 
         + "\n  Account Ballance = " + DoubleToStr(AccountBalance(), 2);
         if (li_152 == 0 && li_156 == 0) {
            ls_0 = ls_0 
               + "\n  No active trades" 
            + "\n";
         } else {
            if (li_152 > 0) {
               ls_0 = ls_0 
               + "\n  Buy average price " + DoubleToStr(ld_104, Digits);
            }
            if (li_156 > 0) {
               ls_0 = ls_0 
               + "\n  Sell average price " + DoubleToStr(ld_112, Digits);
            }
            ls_0 = ls_0 
               + "\n  Current trade " + DoubleToStr(ld_64, 1) + " pips" 
            + "\n  Account Profit = " + DoubleToStr(ld_72, 2);
         }
         Comment(ls_0);
      }
   }
   if (IsTesting() && StringSubstr(Symbol(), 0, 6) == "EURUSD" && Year() < 2008) return (0);
   if (IsTesting() && StringSubstr(Symbol(), 0, 6) == "GBPUSD" && Year() < 2008 || (Year() == 2008 && Month() < 9)) return (0);
   if (gi_124 && iVolume(NULL, PERIOD_M1, 0) > 1.0) return (0);
   HideTestIndicators(TRUE);
   double ld_224 = iOpen(NULL, PERIOD_M1, 1);
   double ld_232 = iClose(NULL, PERIOD_M1, 1);
   double ld_240 = iBands(NULL, PERIOD_M15, BandPer, 2, 0, PRICE_CLOSE, MODE_UPPER, 1);
   double ld_248 = iBands(NULL, PERIOD_M15, BandPer, 2, 0, PRICE_CLOSE, MODE_LOWER, 1);
   double ld_256 = iBands(NULL, PERIOD_M15, BandPer_Open, 2, 0, PRICE_CLOSE, MODE_UPPER, 1);
   double ld_264 = iBands(NULL, PERIOD_M15, BandPer_Open, 2, 0, PRICE_CLOSE, MODE_LOWER, 1);
   double ld_272 = iMA(NULL, PERIOD_H4, TrendPer, 0, MODE_SMMA, PRICE_CLOSE, 1);
   double ld_280 = iMA(NULL, PERIOD_H4, gi_232, 0, MODE_SMMA, PRICE_CLOSE, 1);
   double ld_288 = iATR(NULL, PERIOD_M15, BandPer, 1);
   double ld_296 = iRSI(NULL, PERIOD_M15, 0, BandPer, 1);
   double ld_304 = iATR(NULL, PERIOD_H4, TrendPer, 1);
   double ld_312 = iRSI(NULL, PERIOD_H4, 0, TrendPer, 1);
   HideTestIndicators(FALSE);
   if (li_152 > 0) {
      if (CheckClose(AuthStatus, ld_232, ld_240 + BreakExit * gd_356, ld_248 - BreakExit * gd_356, Bid, f0_2(), ld_288, ld_296) == 0) li_136 = TRUE;
      if ((Bid >= ld_104 + ForceProfit * gd_356 && CheckExitTimeFP(AuthStatus, TimeCurrent() - li_144, ld_304, ld_312)) || Bid <= ld_104 - ForceLoss * gd_356) li_136 = TRUE;
      if (Bid >= ld_104 + gi_240 * gd_356 && CheckExitTime(AuthStatus, TimeCurrent() - li_144, ld_304, ld_312)) li_136 = TRUE;
      if (Bid >= ld_104 + gi_248 * gd_356 && ld_224 > ld_232) li_136 = TRUE;
   }
   if (li_156 > 0) {
   // bid >> ask
      if (CheckClose(AuthStatus, ld_232, ld_240 + BreakExit * gd_356, ld_248 - BreakExit * gd_356, Ask, f0_2(), ld_288, ld_296) == 1) li_140 = TRUE;
      if ((Ask <= ld_112 - ForceProfit * gd_356 && CheckExitTimeFP(AuthStatus, TimeCurrent() - li_148, ld_304, ld_312)) || Ask >= ld_112 + ForceLoss * gd_356) li_140 = TRUE;
      if (Ask <= ld_112 - gi_240 * gd_356 && CheckExitTime(AuthStatus, TimeCurrent() - li_148, ld_304, ld_312)) li_140 = TRUE;
      if (Ask <= ld_112 - gi_248 * gd_356 && ld_224 < ld_232) li_140 = TRUE;
   }
   if (li_136 || li_140) {
      for (li_216 = 0; li_216 <= OrdersTotal() - 1; li_216++) {
         if (!OrderSelect(li_216, SELECT_BY_POS, MODE_TRADES)) Print("Error in OrderSelect! Position:", li_216);
         else {
            if (OrderType() <= OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == Magic) {
               if (OrderType() == OP_BUY && li_136) {
                  for (int li_172 = 1; li_172 <= MathMax(1, gi_276); li_172++) {
                     RefreshRates();
                     if (OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Bid, Digits), Slippage, Violet)) {
                        li_152--;
                        li_216--;
                        break;
                     }
                     Sleep(MathMax(100, 1000 * gi_280));
                  }
                  Sleep(5000);
                  continue;
               }
               if (OrderType() == OP_SELL && li_140) {
                  for (li_172 = 1; li_172 <= MathMax(1, gi_276); li_172++) {
                     RefreshRates();
                     if (OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Ask, Digits), Slippage, Violet)) {
                        li_156--;
                        li_216--;
                        break;
                     }
                     Sleep(MathMax(100, 1000 * gi_280));
                  }
                  Sleep(5000);
               }
            }
         }
      }
   }
   bool li_320 = TRUE;
   bool li_324 = TRUE;
   if (NFA == TRUE && li_156 > 0 || li_164 > 0 || li_160 > 0) li_320 = FALSE;
   if (NFA == TRUE && li_152 > 0 || li_160 > 0 || li_164 > 0) li_324 = FALSE;
   if (gi_104 == TRUE && li_156 > 0 || li_164 > 0) li_320 = FALSE;
   if (gi_104 == TRUE && li_152 > 0 || li_160 > 0) li_324 = FALSE;
   if (OrdersTotal() >= gi_200) return (0);
   if (DayOfWeek() == 5 && Hour() >= gi_304 && f0_2() >= gi_252) return (0);
   if (ld_256 - ld_264 < gi_244 * gd_356) return (0);
   int li_36 = -1;
   if (li_152 <= MaxNegAdds) {
      if ((li_152 < 1 && CheckOpen(AuthStatus, ld_232, ld_256 + BreakEntry * gd_356, ld_256 + MaxBreakEntry * gd_356, ld_264 - BreakEntry * gd_356, ld_264 - MaxBreakEntry * gd_356, MathMin(ld_272 +
         gi_228 * gd_356, ld_280 + gi_236 * gd_356), MathMax(ld_272 - gi_228 * gd_356, ld_280 - gi_236 * gd_356), Ask, f0_2()) == 0) || (li_152 >= 1 && Ask < ld_88 - BetterPricePips * gd_356)) {
         if (Ask - Bid > MaxSpread * gd_356) {
            Print("BUY not taken!!! - High spead...");
            Sleep(1000);
         } else {
            if (!li_320) {
               Print("BUY not taken!!! - No Hedge, or FIFO restriction ...");
               Sleep(1000);
            } else {
               ls_328 = "BUY";
               li_36 = 0;
               li_32 = Aqua;
               RefreshRates();
               ld_8 = NormalizeDouble(Ask, Digits);
            }
         }
      }
   }
   if (li_156 <= MaxNegAdds) {
      if ((li_156 < 1 && CheckOpen(AuthStatus, ld_232, ld_256 + BreakEntry * gd_356, ld_256 + MaxBreakEntry * gd_356, ld_264 - BreakEntry * gd_356, ld_264 - MaxBreakEntry * gd_356, MathMin(ld_272 +
         gi_228 * gd_356, ld_280 + gi_236 * gd_356), MathMax(ld_272 - gi_228 * gd_356, ld_280 - gi_236 * gd_356), Bid, f0_2()) == 1) || (li_156 >= 1 && Bid > ld_96 + BetterPricePips * gd_356)) {
         if (Ask - Bid > MaxSpread * gd_356) {
            Print("SELL not taken!!! - High spead...");
            Sleep(1000);
         } else {
            if (!li_324) {
               Print("SELL not taken!!! - No Hedge, or FIFO restriction ...");
               Sleep(1000);
            } else {
               ls_328 = "SELL";
               li_36 = 1;
               li_32 = Red;
               RefreshRates();
               ld_8 = NormalizeDouble(Bid, Digits);
            }
         }
      }
   }
   if (li_36 >= OP_BUY && f0_3()) {
      for (li_172 = 1; li_172 <= MathMax(1, gi_276); li_172++) {
         li_168 = OrderSend(Symbol(), li_36, ld_40, ld_8, Slippage * (gd_356 / Point), 0, 0, EA_Comment, Magic, 0, li_32);
         if (li_168 >= 0) break;
         Sleep(MathMax(100, 1000 * gi_280));
         RefreshRates();
         if (li_36 == OP_BUY) ld_8 = NormalizeDouble(Ask, Digits);
         else
            if (li_36 == OP_SELL) ld_8 = NormalizeDouble(Bid, Digits);
      }
      Sleep(1000);
      if (li_168 > 0) {
         if (OrderSelect(li_168, SELECT_BY_TICKET, MODE_TRADES)) {
            Print("Order " + ls_328 + " opened!: ", OrderOpenPrice());
            if (FixedTakeProfit > 0 || FixedStopLoss > 0) {
               if (OrderType() == OP_BUY) {
                  if (li_152 == 0) {
                     ld_184 = 0;
                     ld_192 = 0;
                     if (FixedStopLoss > 0) ld_184 = MathMin(OrderOpenPrice() - FixedStopLoss * gd_356, Bid - gi_316 * Point);
                     if (FixedTakeProfit > 0) ld_192 = MathMax(OrderOpenPrice() + FixedTakeProfit * gd_356, Ask + gi_316 * Point);
                  }
                  if (MathAbs(ld_184 - OrderStopLoss()) >= Point || MathAbs(ld_192 - OrderTakeProfit()) >= Point) OrderModify(OrderTicket(), OrderOpenPrice(), ld_184, ld_192, 0, CLR_NONE);
               } else {
                  if (OrderType() == OP_SELL) {
                     if (li_156 == 0) {
                        ld_200 = 0;
                        ld_208 = 0;
                        if (FixedStopLoss > 0) ld_200 = MathMax(OrderOpenPrice() + FixedStopLoss * gd_356, Ask + gi_316 * Point);
                        if (FixedTakeProfit > 0) ld_208 = MathMin(OrderOpenPrice() - FixedTakeProfit * gd_356, Bid - gi_316 * Point);
                     }
                     if (MathAbs(ld_200 - OrderStopLoss()) >= Point || MathAbs(ld_208 - OrderTakeProfit()) >= Point) OrderModify(OrderTicket(), OrderOpenPrice(), ld_200, ld_208, 0, CLR_NONE);
                  }
               }
            }
         }
      } else Print("Error opening " + ls_328 + " order!: ", GetLastError());
      Sleep(4000);
   }
   return (0);
}

double f0_1() {
   double ld_16;
   int li_24;
   double ld_28;
   int li_36;
   double ld_40;
   int li_48;
   double ld_52;
   int li_60;
   double ld_8 = 1;
   if (gd_268 > 0.0 && AutoMM > 0.0) {
      ld_16 = 0;
      li_24 = 0;
      ld_28 = 0;
      li_36 = 0;
      ld_40 = 0;
      li_48 = 0;
      for (int li_64 = OrdersHistoryTotal() - 1; li_64 >= 0; li_64--) {
         if (OrderSelect(li_64, SELECT_BY_POS, MODE_HISTORY)) {
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic) {
               li_24++;
               ld_16 += OrderProfit();
               if (ld_16 > ld_40) {
                  ld_40 = ld_16;
                  li_48 = li_24;
               }
               if (ld_16 < ld_28) {
                  ld_28 = ld_16;
                  li_36 = li_24;
               }
               if (li_24 >= gi_256) break;
            }
         }
      }
      if (li_48 <= li_36) ld_8 = MathPow(gd_268, li_36);
      else {
         ld_16 = ld_40;
         li_24 = li_48;
         ld_52 = ld_40;
         li_60 = li_48;
         for (li_64 = OrdersHistoryTotal() - li_48 - 1; li_64 >= 0; li_64--) {
            if (OrderSelect(li_64, SELECT_BY_POS, MODE_HISTORY)) {
               if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic) {
                  if (li_24 >= gi_256) break;
                  li_24++;
                  ld_16 += OrderProfit();
                  if (ld_16 < ld_52) {
                     ld_52 = ld_16;
                     li_60 = li_24;
                  }
               }
            }
         }
         if (li_60 == li_48 || ld_52 == ld_40) ld_8 = MathPow(gd_268, li_36);
         else {
            if (MathAbs(ld_28 - ld_40) / MathAbs(ld_52 - ld_40) >= (gd_260 + 100.0) / 100.0) ld_8 = MathPow(gd_268, li_36);
            else ld_8 = MathPow(gd_268, li_60);
         }
      }
   }
   for (double ld_0 = MathMax(gd_320, MathMin(gd_328, MathCeil(MathMin(AutoMM_Max, ld_8 * AutoMM) / 100.0 * AccountFreeMargin() / gd_336 / (gi_344 / 100)) * gd_336)); ld_0 >= 2.0 * gd_320 &&
      1.05 * (ld_0 * gd_348) >= AccountFreeMargin(); ld_0 -= gd_320) {
   }
   return (ld_0);
}

int f0_3() {
   int li_4;
   bool li_0 = TRUE;
   if (gi_284 > 0 && gi_288 > 0) {
      li_4 = 0;
      for (int li_8 = OrdersHistoryTotal() - 1; li_8 >= 0; li_8--) {
         if (OrderSelect(li_8, SELECT_BY_POS, MODE_HISTORY)) {
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic) {
               if (!((OrderType() == OP_BUY && (OrderClosePrice() - OrderOpenPrice()) / gd_356 <= (-gi_284)) || (OrderType() == OP_SELL && (OrderOpenPrice() - OrderClosePrice()) / gd_356 <= (-gi_284)))) break;
               li_4 = OrderCloseTime();
               break;
            }
         }
      }
      if (TimeCurrent() - li_4 < 3600 * gi_288) li_0 = FALSE;
   }
   return (li_0);
}

int f0_2() {
   int li_0 = Hour();
   li_0 -= gi_304;
   if (li_0 > 23) li_0 -= 24;
   if (li_0 < 0) li_0 += 24;
   return (li_0);
}

int f0_4() {
   if (gi_152) MyPair = StringSubstr(gs_gbpusd_156, 0, 6);
   else MyPair = StringSubstr(Symbol(), 0, 6);
   int li_0 = SessionInit(AccountNumber(), IsTesting(), IsDemo(), WindowHandle(Symbol(), Period()), MyPair, TimeCurrent());
   if (li_0 == -8 && StringFind(",GBPUSD,", "," + MyPair + ",") >= 0) {
      Comment("\nUpdating settings (" + MyPair + ")...");
      li_0 = SessionDeinit(AccountNumber(), IsTesting(), IsDemo(), WindowHandle(Symbol(), Period()), MyPair);
      Sleep(3000);
      li_0 = SessionInit(AccountNumber(), IsTesting(), IsDemo(), WindowHandle(Symbol(), Period()), MyPair, TimeCurrent());
   }
   if (li_0 >= 0) {
      if (!IsTesting() && AutoGMT_Offset == TRUE) gi_304 = GMTOffset();
      else gi_304 = ManualGMT_Offset;
      if (BetterPricePips <= 0) BetterPricePips = ParamValue(li_0, "BetterPricePips");
      if (ForceProfit <= 0) ForceProfit = ParamValue(li_0, "ForceProfit");
      if (ForceLoss <= 0) ForceLoss = ParamValue(li_0, "ForceLoss");
      if (FixedTakeProfit <= 0) FixedTakeProfit = ParamValue(li_0, "FixedTakeProfit");
      if (FixedStopLoss <= 0) FixedStopLoss = ParamValue(li_0, "FixedStopLoss");
      if (BandPer == 0) BandPer = ParamValue(li_0, "BandPer");
      if (BandPer_Open == 0) BandPer_Open = ParamValue(li_0, "BandPer_Open");
      if (BreakEntry == 0) BreakEntry = ParamValue(li_0, "BreakEntry");
      if (MaxBreakEntry == 0) MaxBreakEntry = ParamValue(li_0, "MaxBreakEntry");
      if (BreakExit == 0) BreakExit = ParamValue(li_0, "BreakExit");
      if (TrendPer == 0) TrendPer = ParamValue(li_0, "TREND_PER");
      if (gi_228 == 0) gi_228 = ParamValue(li_0, "TrendDist");
      if (gi_232 == 0) gi_232 = ParamValue(li_0, "TREND_PER_2");
      if (gi_236 == 0) gi_236 = ParamValue(li_0, "TrendDist_2");
      if (gi_240 == 0) gi_240 = ParamValue(li_0, "ExitTimeProfit");
      if (gi_244 == 0) gi_244 = ParamValue(li_0, "MinBandDist");
      if (gi_248 == 0) gi_248 = ParamValue(li_0, "RescueProfit");
      if (gi_252 < 0) gi_252 = ParamValue(li_0, "FridayEndHour");
   }
   return (li_0);
}

int SessionOff() {
   int li_0;
   if (gi_152) li_0 = SessionDeinit(AccountNumber(), IsTesting(), IsDemo(), WindowHandle(Symbol(), Period()), StringSubstr(gs_gbpusd_156, 0, 6));
   else li_0 = SessionDeinit(AccountNumber(), IsTesting(), IsDemo(), WindowHandle(Symbol(), Period()), StringSubstr(Symbol(), 0, 6));
   return (li_0);
}

//decompiled by nixxer

int SessionInit(int accnum, int istest, int isdem, int winhandle, string pairname, int currtime)
{
   return(1);
}

int ParamValue(int a0, string a1)
{
   string pairname = StringSubstr(Symbol(), 0, 6);
   if (pairname=="EURUSD")
   {
      _EXITTIME = 490;
      _EXITTIMEFORCEPROFIT = 0;
      _NOTRENDHOUR1 = 4;
      _NOTRENDHOUR2 = 18;
      _NOTRENDHOUR3 = 55;
      _NOTRENDHOUR4 = 55;
      
      _BETTERPRICEPIPS = 6;
      if (a1=="BetterPricePips") return (_BETTERPRICEPIPS);
      _FORCEPROFIT = 9;
      if (a1=="ForceProfit") return (_FORCEPROFIT);
      _FORCELOSS = 300;
      if (a1=="ForceLoss") return (_FORCELOSS);
      _FIXEDTAKEPROFIT = 0;
      if (a1=="FixedTakeProfit") return (_FIXEDTAKEPROFIT);
      _FIXEDSTOPLOSS = 0;
      if (a1=="FixedStopLoss") return (_FIXEDSTOPLOSS);
      _BANDPER = 19;
      if (a1=="BandPer") return (_BANDPER);
      _BANDPER_OPEN = 15;
      if (a1=="BandPer_Open") return (_BANDPER_OPEN);
      _BREAKENTRY = 3;
      if (a1=="BreakEntry") return (_BREAKENTRY);
      _MAXBREAKENTRY = 8;
      if (a1=="MaxBreakEntry") return (_MAXBREAKENTRY);
      _BREAKEXIT = 3;
      if (a1=="BreakExit") return (_BREAKEXIT);
      _TREND_PER = 22;
      if (a1=="TREND_PER") return (_TREND_PER);
      _TRENDDIST = 100;
      if (a1=="TrendDist") return (_TRENDDIST);
      _TREND_PER_2 = 5;
      if (a1=="TREND_PER_2") return (_TREND_PER_2);
      _TRENDDIST_2 = 55;
      if (a1=="TrendDist_2") return (_TRENDDIST_2);
      _EXITTIMEPROFIT = -40;
      if (a1=="ExitTimeProfit") return (_EXITTIMEPROFIT);
      _MINBANDDIST = 8;
      if (a1=="MinBandDist") return (_MINBANDDIST);
      _RESCUEPROFIT = 7;
      if (a1=="RescueProfit") return (_RESCUEPROFIT);
      _FRIDAYENDHOUR = 21;
      if (a1=="FridayEndHour") return (_FRIDAYENDHOUR);
  }    
  if (pairname=="GBPUSD")
  {
      _EXITTIME=600;
      _EXITTIMEFORCEPROFIT=0;
      _NOTRENDHOUR1=22;
      _NOTRENDHOUR2=15;
      _NOTRENDHOUR3=55;
      _NOTRENDHOUR4=55;
      _BETTERPRICEPIPS = 15;
      if (a1=="BetterPricePips") return (_BETTERPRICEPIPS);
      _FORCEPROFIT = 20;
      if (a1=="ForceProfit") return (_FORCEPROFIT);
      _FORCELOSS = 380;
      if (a1=="ForceLoss") return (_FORCELOSS);
      _FIXEDTAKEPROFIT = 0;
      if (a1=="FixedTakeProfit") return (_FIXEDTAKEPROFIT);
      _FIXEDSTOPLOSS = 0;
      if (a1=="FixedStopLoss") return (_FIXEDSTOPLOSS);
      _BANDPER = 22;
      if (a1=="BandPer") return (_BANDPER);
      _BANDPER_OPEN = 10;
      if (a1=="BandPer_Open") return (_BANDPER_OPEN);
      _BREAKENTRY = 1;
      if (a1=="BreakEntry") return (_BREAKENTRY);
      _MAXBREAKENTRY = 50;
      if (a1=="MaxBreakEntry") return (_MAXBREAKENTRY);
      _BREAKEXIT = 9;
      if (a1=="BreakExit") return (_BREAKEXIT);
      _TREND_PER = 21;
      if (a1=="TREND_PER") return (_TREND_PER);
      _TRENDDIST = 100;
      if (a1=="TrendDist") return (_TRENDDIST);
      _TREND_PER_2 = 21;
      if (a1=="TREND_PER_2") return (_TREND_PER_2);
      _TRENDDIST_2 = 100;
      if (a1=="TrendDist_2") return (_TRENDDIST_2);
      _EXITTIMEPROFIT = 11;
      if (a1=="ExitTimeProfit") return (_EXITTIMEPROFIT);
      _MINBANDDIST = 11;
      if (a1=="MinBandDist") return (_MINBANDDIST);
      _RESCUEPROFIT = 19;
      if (a1=="RescueProfit") return (_RESCUEPROFIT);
      _FRIDAYENDHOUR = 14;
      if (a1=="FridayEndHour") return (_FRIDAYENDHOUR);
   }
  Alert("Pairname-",pairname," invalid");
  return(0);
}

int CheckOpen(int a0, double a1, double bube, double bumbe, double blbe, double blmbe, double minma, double maxma, double price, int h)
{
   if ((price < blbe) && (price > blmbe) && (price > minma))
   {
       return (0);
   }
   if ((price < blbe) && (price > blmbe) && ((h==_NOTRENDHOUR1) || (h==_NOTRENDHOUR2) || (h==_NOTRENDHOUR3) || (h==_NOTRENDHOUR4)))
   {
   
       return (0);
   }    
   if ((price > bube) && (price < bumbe) && (price < maxma)) 
   {
      return (1);
   }
   if ((price > bube) && (price < bumbe) && ((h==_NOTRENDHOUR1) || (h==_NOTRENDHOUR2) || (h==_NOTRENDHOUR3) || (h==_NOTRENDHOUR4)))
   {
  
      return (1);   
   }
   return (-1);
}

int CheckClose(int a0, double a1, double a2, double a3, double a4, int a5, double a6, double a7)
{
   if ((a7 >= 0.0) && (a6 > 0.0))
   {
    if (a4 <= a2)
     {
      if (a4 < a3) return(1);
     }
    else
     return(0);
     
   }
   return (-1);
   
}

bool CheckExitTime(int a0, int a1, double a2, double a3)
{
   if ((a3 >= 0.0) && (a2 > 0.0) && ( a1>(_EXITTIME*60) )) return (true);
   return (false);
}

bool CheckExitTimeFP(int a0, int a1, double atr, double rsi)
{
   if ((rsi >= 0.0) && (atr > 0.0) && ( a1>(_EXITTIMEFORCEPROFIT*60) )) return (true);
   return (false);
}

int GMTOffset()
{
   return (ManualGMT_Offset);
}

int SessionDeinit(int a0, int a1, int a2, int a3, string a4)
{
   return (1);
}

